(in-package :oou)
(oou-provide :WMgr-view)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; WMgr-view.Lisp
;;
;; Copyright  1991 Northwestern University Institute for the Learning Sciences
;; All Rights Reserved
;;
;; author: Michael S. Engber
;;
;; Provides a view based on the Window Manager port
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(export '(*WMgr-view*))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defclass WMgr-view (simple-view) ())

(defmethod view-origin ((sv  WMgr-view)) (declare (ignore sv)) #@(0 0))

(defmethod view-clip-region ((sv WMgr-view))
  (pref (wptr sv) :CGrafPort.visRgn))

(defmethod wptr ((sv WMgr-view))
  (if (pointerp (slot-value sv 'wptr))
    (slot-value sv 'wptr)
    (setf (slot-value sv 'wptr)
          (rlet ((pp :pointer))
            (if *color-available*
              (#_GetCWMgrPort pp)
              (#_GetWMgrPort pp))
            (%get-ptr pp)))))

(defvar *WMgr-view* (make-instance 'WMgr-view))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;